/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
   
    file: bitmap.cpp
*/


#include "core.h"
#include "compress.h"


/* Save processed frame to a numbered file */
void save_to_disk_old(char * text, color_type *frame) 
{
    static int next_file_num = 1;

    SYSTEMTIME st;
    GetLocalTime(&st); 



    char b[300];


    char ts[200];

    get_time_str(ts);

    
    sprintf(b, "images\\%s",ts);




    char filename[100];
    sprintf(filename, "Save to: %s.bmp", b);
  //  add_line(filename);

    sprintf(filename, "%s.bmp", b);

    HANDLE hf;                 // file handle 

    // bitmap file heared
    BITMAPFILEHEADER hdr;       // bitmap file-header 

    // Createa a pointer to the bitmap info header
    BITMAPINFOHEADER *binfo = &camera_buffer_info.bmiHeader; 











HDC pDC = ::GetDC(0);
HDC TmpDC=CreateCompatibleDC(pDC);

HBITMAP TmpBmp=CreateDIBSection(pDC,
    &camera_buffer_info,DIB_RGB_COLORS,(void**)&temp_frame,0,0);

HGDIOBJ TmpObj=SelectObject(TmpDC,TmpBmp);

  memcpy(temp_frame, frame,  binfo->biSizeImage); 
        
   TextOut(TmpDC, 2, 2, text, strlen(text));










    DWORD dwTotal;              // total count of bytes 
    DWORD cb;                   // incremental count of bytes 
    DWORD tmp; 

    // Create the .BMP file. 
    hf = CreateFile(filename, GENERIC_READ | GENERIC_WRITE, 0, 
                    NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); 
   
    hdr.bfType = 0x4d42;  // "BM"
      
    // file size
    hdr.bfSize = sizeof(BITMAPFILEHEADER) + binfo->biSize + binfo->biSizeImage; 


    console("sz: %d\n", binfo->biSizeImage);



    hdr.bfReserved1 = 0; 
    hdr.bfReserved2 = 0; 

    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + binfo->biSize;

    // save file header
    WriteFile(hf, &hdr, sizeof(BITMAPFILEHEADER), &tmp, NULL);

    // save bitmap info
    WriteFile(hf, (LPVOID) binfo, sizeof(BITMAPINFOHEADER), &tmp, NULL); 

   /* if (fast_capture)
    {
        // mirror image if we are using fast capture
        for (int y = 0; y < size_y; y++)
        {
            memcpy(temp_frame + (size_y - y - 1) * size_x,
                   frame + y * size_x, size_x * 4);
        }
     }
    else
        memcpy(temp_frame, frame,  binfo->biSizeImage); */



    // save image data
    WriteFile(hf, temp_frame, binfo->biSizeImage, &tmp, NULL);

    CloseHandle(hf);
}
/* end of save bitmap */



/* Save processed frame to a numbered file */
void save_to_disk(char * filename, char * text, color_type *frame) 
{
    unsigned int max = size_x * size_y * 4;
    unsigned int out_size;

    unsigned char *buff = (unsigned char * )malloc(max);
    unsigned char *tbuff = (unsigned char * )malloc(max);





    // Create the .BMP file. 
     HANDLE hf = CreateFile(filename, GENERIC_READ | GENERIC_WRITE, 0, 
                    NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); 
    
    // Setup to write text to image
    BITMAPINFOHEADER *binfo = &camera_buffer_info.bmiHeader; 

    HDC pDC = ::GetDC(0);
    HDC TmpDC=CreateCompatibleDC(pDC);

    HBITMAP TmpBmp=CreateDIBSection(pDC, &camera_buffer_info,
                                    DIB_RGB_COLORS,(void**)&temp_frame,0,0);

    HGDIOBJ TmpObj=SelectObject(TmpDC,TmpBmp);

    memcpy(temp_frame, frame,  binfo->biSizeImage); 
        
    TextOut(TmpDC, 2, 2, text, strlen(text));


    compress_frame((unsigned char *)temp_frame, 
                   (unsigned char *)buff,
                   (unsigned char *)tbuff,
                    max, &out_size, size_x, size_y);

    DWORD tmp;               

    // save image data
    WriteFile(hf, buff, out_size, &tmp, NULL);

    free(buff);
    free(tbuff);

    CloseHandle(hf);
}
/* end of save bitmap */


